const request = require('request')
const CHECK = require('./validator')

let HOST
let ERRORS
let getBearerKey

function build (params) {
  CHECK.buildData(params)
  if (params.autorization && !getBearerKey) throw 'APIBuilder: function getBearerKey is undefined'
  return input => new Promise((resolve, reject) => {
    let url = params.url
    const options = {}
    if (params.input && params.transformInput) {
      options.json = params.transformInput(input)
    } else if (params.input){
      options.json = input
      for (let i in input) { url = url.replace(`<${i}>`, input[i]) }
    } else if (!params.input) {
      options.json = true
    }
    if (params.autorization) options['auth'] = { bearer: getBearerKey(options.json) }
    request[params.method](HOST + url, options, (error, response, body) => {
      if(response.statusCode > 199 && response.statusCode < 300 && params.transformOutput) {
        resolve(params.transformOutput(body))
      } else if (response.statusCode > 199 && response.statusCode < 300) {
        resolve(body)
      } else {
        let msg
        if (ERRORS[response.statusCode]) msg = ERRORS[response.statusCode](body)
        msg = msg || 'API-Builder: unhandled qequest error'
        reject({ url: HOST + url, code: response.statusCode, options, msg, body })
      }
    })
  })
}

module.exports = function APIBuilder (inits) {
  ({ HOST, ERRORS, getBearerKey } = inits)
  CHECK.initData(inits)
  return build
}