const schema = require('js-schema')

const ShemaDataInit = schema({
  HOST: String,
  '?ERRORS': Object,
  '?getBearerKey': Function
})

const SchemaBuildData = schema({
  url: String,
  method: ['post', 'get', 'put', 'patch', 'delete'],
  '?input': Object,
  '?transformInput': Function,
  '?output': Object,
  '?transformOutput': Function
})

module.exports = {
  initData: data => {
    if (!ShemaDataInit(data)) {
      throw 'APIBuilder: format error\n' + JSON.stringify(ShemaDataInit.errors(data), false, 2)
    }
  },
  buildData: (data) => {
    if (!SchemaBuildData(data)){
      throw 'APIBuilder: Format error. ' + data.url + '\n' + JSON.stringify(SchemaBuildData.errors(data), false, 2)
    }
  }
}