const APIBuilder = require('./api-builder')

module.exports = {
  APIBuilder: APIBuilder
}

// let testKey = '6b4eab3d98b07ecd33db1e6d66c6f177f79d8d89'

const mkReq = APIBuilder({
  HOST: 'http://165.22.26.193:8000',
  ERRORS: {
    400: (body) => {
      if (body.password1 && body.password1.indexOf('This password is too short. It must contain at least 8 characters.') + 1) return 'Слишком короткий пароль'
      if (body.password1 && body.password1.indexOf('This password is too common.') + 1) return 'Слишком распространенный пароль'
      else if (body.email && body.email.indexOf('A user is already registered with this e-mail address.') + 1) return 'Такой email уже существует'
      else if (body.email && body.email.indexOf('Enter a valid email address.') + 1) return 'Некорректный email'
    },
    401: (body) => {
      if (body.detail && body.detail === 'Invalid token.') return 'Неверный Bearer Token'
      else if (body.detail && body.detail === 'Authentication credentials were not provided.') return 'web-токен не был предоставлен'
      else if (body.password1 && body.password1.indexOf('This password is too common.') + 1) return 'Слишком распространенный пароль'
      else if (body.email && body.email.indexOf('A user is already registered with this e-mail address.') + 1) return 'Такой email уже существует'
    }
  },
  getBearerKey () {
    return testKey
  },
})

// mkReq({
//   url: '/shop/offers/<id>',
//   method: 'get',
//   input: {
//     id: Number
//   }
// })({ id : 1 }).then(console.log).catch(console.error)

// mkReq({
//   url: '/garage/offers/',
//   method: 'get',
//   autorization: true
// })().then(console.log).catch(console.error)

// mkReq({
//   url: '/users/registration/',
//   method: 'post',
//   input: {
//     email: String,
//     name: String,
//     password: String,
//     isOwner: Boolean
//   },
//   transformInput: input => { return {
//     email: input.email,
//     username: input.name,
//     password1: input.password,
//     password2: input.password,
//     is_owner: input.isOwner
//   }},
//   output: {
//     key: String
//   },
//   transformOutput: output => {
//     return output.key
//     // Cookies.set(webTokenField, output.key)
//     // return 'Вы успешно зарегистрировались'
//   }
// })({
//   email: 'test62@gmail.com',
//   name: 'test62',
//   password: 'qweqwe123123',
//   isOwner: true
// }).then(console.log).catch(console.error)
